//
// SAMPLE PROGRAM TO ILLUSTRATE UNDEFINED REFERENCE ERROR
//

#include <targets/TMS470.h>
#include <targets/TMS470HET.h>
#include "std_het.h"
#include "main_het.h"

extern unsigned HETRAMStart; // Linker Symbol defined in the memory map file

//========================================================================
void memcpy32(unsigned *dst, unsigned *src, int num)
{
  int i;
  for (i = 0; i < num; i++)
    *dst++ = *src++;
}

//========================================================================
static void HET1ISR (void)
{

    if (HETOFF1 & 0x01)
    {
        unsigned tmp = HET_L00_0.memory.control_word & 0x000FFFFF;   // RETRIEVE THE PULSE WIDTH COUNT  

        // ## DO SOMETHING USEFUL WITH THE PULSEWIDTH HERE
    }
}

//========================================================================
int main (void)
{
  unsigned i;

  PCR = 0x1E;
  PCR = 0x1F;  // enable peripherals


    HETGCR = HETGCR_CLKMasterSlave | HETGCR_IgnoreSusp;   // HET Master Mode, Ignore SW BP

    // copy HET program to HET memory
    memcpy32(&HETRAMStart, (unsigned*)HET_INIT0_PST, sizeof(HET_INIT0_PST)/sizeof(unsigned));

    HETPFR = 0x00000309;                    // Set PFR register /8 /10
    HETPRY = 0xFF;                          // Set priority for HET interrupt

    // ## HOOK INTERRUPT VECTOR AND ENABLE HET1 INTERRUPTS HERE

    // START THE HET
    HETGCR |= HETGCR_TurnOnOff;

    for (;;)
    {
    }
}

